stored_units = {}

function isGameOnlineOrHost()
    if game_state_machine and game_state_machine:current_state_name() then
        local state = game_state_machine:current_state_name()
        return state == "ingame_standard" or state == "menu_main"
    end
    return false
end

if LuaNetworking:IsMultiplayer() and LuaNetworking:IsClient() then return end

if LuaNetworking:IsHost() then
    if managers and managers.achievment then
        managers.achievment:set_achievements_disabled(true)
    end
end

function store_units_for_batch_processing()
    stored_units = World:find_units_quick("all")  -- Einmalige Abfrage der Einheiten
end

function get_stored_units()
    return stored_units
end

function is_game_initialized()
    return game_state_machine and game_state_machine:current_state_name() == "ingame_standard" and managers and managers.player and managers.player:local_player()
end

function batch_auto_pick_lock_in_range(units, start_index, batch_size)
    if not is_game_initialized() then return end

    local player = managers.player:player_unit()
    if not player then return end

    local player_pos = player:position()
    local custom_interact_distance = 1000
    local end_index = math.min(#units, start_index + batch_size - 1)

    
    for i = start_index, end_index do
        local unit = units[i]
        -- Sicherstellen, dass die Einheit existiert und gültig ist
        if unit and alive(unit) and unit:interaction() then
            local distance = mvector3.distance(player_pos, unit:position())

            if distance <= custom_interact_distance then
                local interaction = unit:interaction()

                -- Absicherung gegen ungültige Interaktionen
                if interaction and (interaction.tweak_data == "pick_lock_hard_no_skill" or interaction.tweak_data == "pick_lock_easy_no_skill") and not interaction:disabled() then
                    if interaction:active() and interaction:can_interact(player) then
                        interaction._timer = 1
                        interaction:interact(player)
                    end
                end
            end
        end
    end

    
    if end_index < #units then
        DelayedCalls:Add("AutoPickLockBatch", 0.01, function()
            -- Absicherung gegen nicht vorhandene oder fehlerhafte Einheiten
            if units and #units > end_index then
                batch_auto_pick_lock_in_range(units, end_index + 1, batch_size)
            end
        end)
    end
end


function auto_pick_lock_in_range_with_batching()
    if not is_game_initialized() then return end

    
    store_units_for_batch_processing()

    local units = get_stored_units()

    
    if units and #units > 0 then
        batch_auto_pick_lock_in_range(units, 1, 30)  
    end
end


local is_processing = false


function AutoLockpickRange_Add_Keybind(keybind_id, default_key)
    Hooks:Add("MenuManagerInitialize", "MenuManagerInitialize_AutoLockpickRange", function(menu_manager)
        
        HoldTheKey:Add_Keybind(keybind_id)
        
        Hooks:Add("GameSetupUpdate", "AutoLockpickRange_CheckKeybind", function()
            if is_processing then return end
            
            if HoldTheKey:Keybind_Held(keybind_id) or Input:keyboard():pressed(Idstring("^")) then
                is_processing = true
                auto_pick_lock_in_range_with_batching()
                
                DelayedCalls:Add("ResetIsProcessing", 0.05, function()
                    is_processing = false
                end)
            end
        end)
    end)
end


AutoLockpickRange_Add_Keybind("dcc_commandprompt_toggle", "~")
